grammar DobjFilterParser;


@header {
	package de.bsvrz.sys.funclib.objfilter.parser;
}

filter
:
	FILTER LE_KLAMMER pid RE_KLAMMER L_KLAMMER operation R_KLAMMER	
;


operation 
:
	operator L_KLAMMER argument? ( ',' argument) * R_KLAMMER
;

operator
:
	OBJEKT
	| MENGE
	| ATTRIBUT
	| ELEMENT
	| NAME
	| ANZAHL
	| ENTHAELT
	| BEGINNTMIT
	| ENDETMIT
	| KLEINER
	| GROESSER
	| GLEICH
	| UNGLEICH
	| KLEINERGLEICH
	| GROESSERGLEICH
	| UND
	| ODER
	| NOT
;

argument
:
	text
	| pid
	| bool
	| zahl
	| operation
;


pid
:
	PID
;

text 
:
	TEXT
;

bool
:
	'wahr'
	| 'falsch'
;

zahl
:
	ZAHL
;



FILTER
:
	'filter'
;

OBJEKT
:
	'objekt'
;

MENGE
:
	'menge'
;

ATTRIBUT
:
	'attribut'
;

ELEMENT
:
	'element'
;

NAME
:
	'name'
;

ANZAHL
:
	'anzahl'
;

ENTHAELT
:
	'enthaelt'
;

BEGINNTMIT
:
	'beginntMit'
;

ENDETMIT
:
	'endetMit'
;

KLEINER
:
	'kleiner'
;

GROESSER
:
	'groesser'
;

GLEICH
:
	'gleich'
;

UNGLEICH
:
	'ungleich'
;

KLEINERGLEICH
:
	'kleinergleich'
;

GROESSERGLEICH
:
	'groessergleich'
;

UND
:
	'und'
;

ODER
:
	'oder'
;

NOT
:
	'nicht'
;


QUOTE
:
	'"'
;

PUNKT
:
	'.'
;

KOMMA
:
	','
;

L_KLAMMER
:
	'('
;

R_KLAMMER
:
	')'
;

LE_KLAMMER
:
	'['
;

RE_KLAMMER
:
	']'
;

fragment ZIFFER
:
	('0' .. '9')
;

ZAHL
   : ZIFFER+ ('.' ZIFFER+)?
   ;


PID
   : VALID_PID_START VALID_PID_CHAR*
   ;


fragment VALID_PID_START
   : ('a' .. 'z') | ('A' .. 'Z') 
   ;


fragment VALID_PID_CHAR
: 
	VALID_PID_START 
	| ('0' .. '9') 
	| '.' 
	| 'ä'
	| 'Ä'
	| 'ö'
	| 'Ö'
	| 'ü'
	| 'Ü'
	| 'ß'
;

TEXT
:
	'"' TEXTCHAR+ '"'
;

fragment TEXTCHAR
: 
	  ~["]
;

WS
:
 [ \r\n\t] + -> skip
;


